minispade.register('ember-formbuilder/~tests/form_for_test', "(function() {(function() {\n  var appendView, object, view;\n\n  view = null;\n\n  object = null;\n\n  appendView = function() {\n    return Ember.run(function() {\n      return view.appendTo('#qunit-fixture');\n    });\n  };\n\n  module(\"formFor Helper\", {\n    setup: function() {\n      var genders;\n      object = Ember.Object.create();\n      genders = Ember.ArrayProxy.create({\n        content: [\n          {\n            value: 'male',\n            label: 'Male'\n          }, {\n            value: 'female',\n            label: 'Female'\n          }\n        ]\n      });\n      view = Ember.View.create({\n        object: object,\n        genders: genders,\n        template: Ember.Handlebars.compile('\\\n        <section>\\\n          {{#formFor \"object\" classes=\"form-horizontal\"}}\\\n            {{input \"name\"}}\\\n            {{input \"gender\" as=\"select\" collectionBinding=\"parentView.genders\" prompt=\"Please select\"}}\\\n            {{input \"categories\" as=\"checkboxes\" collectionBinding=\"parentView.genders\"}}\\\n            {{input \"option\" as=\"radioButtons\" collectionBinding=\"parentView.genders\"}}\\\n\\\n            {{submit \"Save\"}}\\\n            {{cancel \"Cancel\"}}\\\n          {{/formFor}}\\\n\\\n          <span id=\"name\">{{object.name}}</span>\\\n        </section>\\\n      '),\n        objectSubmit: function() {\n          return this.set('submitFired', true);\n        },\n        objectCancel: function() {\n          return this.set('cancelFired', true);\n        }\n      });\n      return appendView();\n    },\n    teardown: function() {\n      if (view) view.destroy();\n      if (object) return object.destroy();\n    }\n  });\n\n  test(\"basic formFor call for object\", function() {\n    return ok(/<section>.*<form.*<\\/section>.*/.test(view.$().html()), \"form should be correctly set\");\n  });\n\n  test(\"form classes is set\", function() {\n    return ok(view.$('form').hasClass('form-horizontal'));\n  });\n\n  test(\"submit and cancel looks like they should\", function() {\n    var cancel, submit;\n    submit = view.$('form .submit-button');\n    cancel = view.$('form .cancel-button');\n    ok(submit.hasClass('btn btn-success'), 'submit classes');\n    ok(cancel.hasClass('btn btn-danger'), 'cancel classes');\n    equal(submit.get(0).tagName.toLowerCase(), 'button', 'submit tagName');\n    return equal(cancel.get(0).tagName.toLowerCase(), 'a', 'cancel tagName');\n  });\n\n  test(\"submit fires event on the parent view\", function() {\n    var submit;\n    submit = view.$('form .submit-button');\n    Ember.run(function() {\n      return Ember.View.views[submit.attr('id')].click();\n    });\n    return ok(view.submitFired != null);\n  });\n\n  test(\"cancel fires event on the parent view\", function() {\n    var cancel;\n    cancel = view.$('form .cancel-button');\n    Ember.run(function() {\n      return Ember.View.views[cancel.attr('id')].click();\n    });\n    return ok(view.cancelFired != null);\n  });\n\n  test(\"input label\", function() {\n    equal(view.$('form label').first().text().trim(), 'Name', \"should have default label\");\n    return equal(view.$('form label').first().attr('for'), view.$('form input').attr('id'), \"should be for the given input\");\n  });\n\n  test(\"inputs with bindings\", function() {\n    ok(/<section>.*<form.*<\\/section>.*/.test(view.$().html()), \"form should be correctly set\");\n    ok(view.$('form input').length > 0, \"should have inputs\");\n    Ember.run(function() {\n      return object.set('name', 'My Name');\n    });\n    ok(view.$('form input').val() === 'My Name', \"bindings should be bound\");\n    Ember.run(function() {\n      ok(view.$('form input').val('Changed Again'));\n      return Ember.View.views[view.$('form input').attr('id')].change();\n    });\n    ok(object.get('name') === 'Changed Again', \"bindings should be bound both sides\");\n    return ok($('#name').text() === 'Changed Again', \"binds to all instances\");\n  });\n\n  test(\"select tag\", function() {\n    ok(view.$(\"form select\").length > 0, \"should have select tag\");\n    equal(view.$(\"form select\").val(), 'Please select', \"By default, the prompt is selected in the DOM\");\n    return equal(view.$(\"form select\").find('option').length, 3, \"Options were rendered\");\n  });\n\n  test(\"select tag with bindings\", function() {\n    Ember.run(function() {\n      return view.genders.pushObject(Ember.Object.create({\n        label: 'Another',\n        value: 'an'\n      }));\n    });\n    return equal(view.$(\"form select\").find('option').length, 4, \"Options were rendered\");\n  });\n\n  test(\"checkboxes with bindings\", function() {\n    Ember.run(function() {\n      var box;\n      box = view.$(\"form label.checkbox input[type='checkbox']\").last();\n      box.attr('checked', true);\n      Ember.View.views[box.attr('id')].change();\n      return view.genders.pushObject(Ember.Object.create({\n        label: 'Another',\n        value: 'an'\n      }));\n    });\n    equal(view.$(\"form label.checkbox input[type='checkbox']\").length, 3, \"checkboxes were rendered\");\n    return Ember.run(function() {\n      return console.log(view.object.categories);\n    });\n  });\n\n  test(\"radio buttons with bindings\", function() {\n    Ember.run(function() {\n      return view.genders.pushObject(Ember.Object.create({\n        label: 'Another',\n        value: 'an'\n      }));\n    });\n    return equal(view.$(\"form label.radio input[type='radio']\").length, 3, \"radios were rendered\");\n  });\n\n}).call(this);\n})();\n//@ sourceURL=ember-formbuilder/~tests/form_for_test");minispade.register('ember-formbuilder/~tests/mixin', "(function() {(function() {\n  var Custom, appendView, object, view;\n\n  view = null;\n\n  object = null;\n\n  Custom = Ember.Mixin.create({\n    wrapperTag: 'section',\n    wrapperClass: 'custom-group',\n    inputWrapperTag: 'span',\n    inputWrapperClass: 'custom-controls',\n    labelClass: 'custom-label',\n    helpTag: 'span',\n    helpClass: 'help',\n    errorTag: 'p',\n    errorClass: 'error',\n    formClass: 'form',\n    submitClass: 'submit',\n    cancelClass: 'cancel'\n  });\n\n  appendView = function() {\n    return Ember.run(function() {\n      return view.appendTo('#qunit-fixture');\n    });\n  };\n\n  module(\"formFor Helper with mixins\", {\n    setup: function() {\n      object = Ember.Object.create();\n      Ember.FormBuilder.pushMixin(Custom, 'custom');\n      view = Ember.View.create({\n        template: Ember.Handlebars.compile('\\\n        <section>\\\n          {{#formFor \"object\" mixin=\"custom\"}}\\\n            {{input \"name\" hint=\"my hint\" error=\"my error\"}}\\\n          {{/formFor}}\\\n          \\\n          <span id=\"name\">{{object.name}}</span>\\\n        </section>\\\n      ')\n      });\n      view.set('object', object);\n      return appendView();\n    },\n    teardown: function() {\n      if (view) view.destroy();\n      if (object) return object.destroy();\n    }\n  });\n\n  test(\"mixin properties\", function() {\n    ok(view.$('form').hasClass('form'), \"form class\");\n    ok(view.$('form section.custom-group').length > 0, \"wrapper tag\");\n    ok(view.$('form section.custom-group span.custom-controls').length > 0, \"input wrapper tag\");\n    ok(view.$('form section.custom-group label.custom-label').length > 0, \"has a label\");\n    ok(view.$('form section.custom-group span.help').text().trim() === 'my hint', \"hint with class\");\n    return ok(view.$('form section.custom-group p.error').text().trim() === 'my error', \"error with class\");\n  });\n\n}).call(this);\n})();\n//@ sourceURL=ember-formbuilder/~tests/mixin");minispade.register('ember-formbuilder/~tests/translations', "(function() {(function() {\n  var appendView, object, view;\n\n  view = null;\n\n  object = null;\n\n  appendView = function() {\n    return Ember.run(function() {\n      return view.appendTo('#qunit-fixture');\n    });\n  };\n\n  module(\"translations\", {\n    setup: function() {\n      object = Ember.Object.create();\n      view = Ember.View.create({\n        template: Ember.Handlebars.compile('\\\n        <section>\\\n          {{#formFor \"object\" classes=\"form-horizontal\"}}\\\n            {{input \"name\"}}\\\n\\\n            {{submit}}\\\n            {{cancel}}\\\n          {{/formFor}}\\\n          \\\n          <span id=\"name\">{{object.name}}</span>\\\n        </section>\\\n      ')\n      });\n      return view.set('object', object);\n    },\n    teardown: function() {\n      Ember.FormBuilder.STRINGS = {};\n      if (view) view.destroy();\n      if (object) return object.destroy();\n    }\n  });\n\n  test(\"translates attributes correctly with custom values\", function() {\n    Ember.FormBuilder.STRINGS = {\n      defaults: {\n        labels: {\n          name: 'Your name'\n        },\n        hints: {\n          name: 'Full name'\n        },\n        placeholders: {\n          name: 'Type your full name'\n        },\n        submit: 'Submit',\n        cancel: 'Cancel'\n      },\n      object: {\n        labels: {\n          name: 'Type your name:'\n        },\n        hints: {\n          name: 'The name of yours'\n        },\n        placeholders: {\n          name: 'Naaaame'\n        },\n        submit: 'Send',\n        cancel: 'Reset'\n      }\n    };\n    appendView();\n    equal(view.$('form label').text().trim(), 'Type your name:');\n    equal(view.$('form .help-block').text().trim(), 'The name of yours');\n    equal(view.$('form input').attr('placeholder').trim(), 'Naaaame');\n    equal(view.$('form .submit-button').text().trim(), 'Send');\n    return equal(view.$('form .cancel-button').text().trim(), 'Reset');\n  });\n\n  test(\"translates attributes correctly with default values\", function() {\n    Ember.FormBuilder.STRINGS = {\n      defaults: {\n        labels: {\n          name: 'Your name'\n        },\n        hints: {\n          name: 'Full name'\n        },\n        placeholders: {\n          name: 'Type your full name'\n        },\n        submit: 'Submit'\n      }\n    };\n    appendView();\n    equal(view.$('form label').text().trim(), 'Your name');\n    equal(view.$('form .help-block').text().trim(), 'Full name');\n    equal(view.$('form input').attr('placeholder').trim(), 'Type your full name');\n    equal(view.$('form .submit-button').text().trim(), 'Submit');\n    return equal(view.$('form .cancel-button').text().trim(), 'Cancel');\n  });\n\n}).call(this);\n})();\n//@ sourceURL=ember-formbuilder/~tests/translations");